
event ClickAndDrag.OnMouseClick
{
	// Left button was clicked
	if (mouseButton == MB_LEFT)
	{
		// Start dragging
		sender.$Drag = true;	
		
		// Save current object position
		sender.$OrigPos = sender.position;	
		
		// Save current mouse position
		sender.$MousePos = GetMousePosition();
	}
}

event ClickAndDrag.OnUpdate
{
	if (sender.$Drag == true)
	{
		// Calulate how far the mouse has moved
		Vector2 DeltaMove = GetMousePosition() - sender.$MousePos.AsVector2();
		
		// Move object
		sender.position = sender.$OrigPos.AsVector2() + DeltaMove;
	}
}

event ClickAndDrag.OnMouseRelease
{
	// Left button was released
	if (mouseButton == MB_LEFT && sender.$Drag == true)
	{
		// Stop dragging
		sender.$Drag = false;
	}
}
